<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
xmlns:ms="urn:schemas-microsoft-com:xslt"
xmlns:vb="urn:the-xml-files:xslt-vb"
xmlns:js="urn:the-xml-files:xslt-js"
version="1.0">
<xsl:output method="xml"/>

<xsl:template match="/">
<xsl:element name="ROOT">

<xsl:for-each select="ROOT/CATEGORY">
	<xsl:apply-templates select="."/>
</xsl:for-each>

</xsl:element>
</xsl:template>

<xsl:template match="CATEGORY">
	<xsl:call-template name="WriteCategory"/>
	<xsl:for-each select="./TASK">
		<xsl:apply-templates select="."/>
	</xsl:for-each>
	<xsl:for-each select="./CATEGORY">
		<xsl:apply-templates select="."/>
	</xsl:for-each>
</xsl:template>

<xsl:template match="TASK">
	<xsl:call-template name="WriteTask"/>
</xsl:template>

<xsl:template name="WriteCategory">
	<xsl:element name="CATEGORY">
		<xsl:attribute name="PARENTID"><xsl:if test="string-length(../@ID) = 0">0</xsl:if>
		<xsl:value-of select="../@ID"/></xsl:attribute>
		<xsl:copy-of select="./DESCRIPTION | @*"/>
	</xsl:element>
</xsl:template>

<xsl:template name="WriteTask">
	<xsl:element name="TASK">
		<xsl:attribute name="CATEGORYID"><xsl:if test="string-length(../@ID) = 0">0</xsl:if>
		<xsl:value-of select="../@ID"/></xsl:attribute>
		<xsl:copy-of select="./DESCRIPTION | @*"/>
	</xsl:element>
</xsl:template>

</xsl:stylesheet>