﻿<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:ms="urn:schemas-microsoft-com:xslt"
xmlns:vb="urn:the-xml-files:xslt-vb">
<ms:script language="VBScript" implements-prefix="vb">
    <![CDATA[
	'Copyright (c) 2001-2004 Alexander Fedorenko. All Rights Reserved.
	'Do not modify this code. Use separate include instead.
   	Function CalculateHours(planEntriesList)
		Dim sumMinutes
		sumMinutes = 0
		Dim nEntries
		nEntries = planEntriesList.length
		For i = 0 To nEntries-1
			Dim planEntryNode
			Set planEntryNode = planEntriesList.item(i)
			Dim startTime, endTime
			Dim attributes
			Set attributes = planEntryNode.attributes

			startTime = attributes.getNamedItem("STARTTIME").nodeValue
			endTime = attributes.getNamedItem("ENDTIME").nodeValue
			sumMinutes = sumMinutes + DateDiff("n", CDate(startTime), CDate(endTime))
		Next
		CalculateHours = "" & Round(sumMinutes/60, 1)
	End Function

	Function CalculateHoursWONuls(planEntriesList)
		CalculateHoursWONuls = CalculateHours(planEntriesList)
		If CalculateHoursWONuls = 0 Then
			CalculateHoursWONuls = ""
		End If
	End Function
	
	Function GetPlanEntryDate(planEntriesDaysList, isLast)
		Dim borderDate
		borderDate = ""
		Dim nEntries
		nEntries = planEntriesDaysList.length
		For i = 0 To nEntries-1
			Dim planEntryNode
			Set planEntryNode = planEntriesDaysList.item(i)
			Dim attributes
			Set attributes = planEntryNode.attributes
			Dim dayDate
			dayDate = attributes.getNamedItem("DATE").nodeValue
			If borderDate = "" Or IsSelectCriteria(dayDate, borderDate, isLast) Then
				borderDate = dayDate
			End If
		Next
		GetPlanEntryDate = borderDate
	End Function
	
	Function IsSelectCriteria(dayDate, borderDate, isLast)
		If CBool(isLast) Then
			IsSelectCriteria = (dayDate > borderDate)
		Else
			IsSelectCriteria = (dayDate < borderDate)
		End If
	End Function

	Function GetLastPlanEntryDate(planEntriesDaysList)
		GetLastPlanEntryDate = GetPlanEntryDate(planEntriesDaysList, true)
	End Function

	Function GetFirstPlanEntryDate(planEntriesDaysList)
		GetFirstPlanEntryDate = GetPlanEntryDate(planEntriesDaysList, false)
	End Function

	Dim gCategoryFirstDate, gCategoryLastDate, gCategoryLastDateCompleted
	gCategoryFirstDate = ""
	gCategoryLastDate = ""
	gCategoryLastDateCompleted = ""
	Function PushPlanEntryDates(firstPlanEntryDate, lastPlanEntryDate, status)
		If gCategoryFirstDate = "" Then
			gCategoryFirstDate = firstPlanEntryDate
		End If

		If gCategoryLastDate = "" Then
			gCategoryLastDate = lastPlanEntryDate
		End If

		If gCategoryLastDateCompleted = "" Then
			gCategoryLastDateCompleted = lastPlanEntryDate
		End If

		If firstPlanEntryDate <> "" And gCategoryFirstDate > firstPlanEntryDate Then
			gCategoryFirstDate = firstPlanEntryDate
		End If
		
		If lastPlanEntryDate <> "" And gCategoryLastDate < lastPlanEntryDate Then
			gCategoryLastDate = lastPlanEntryDate
		End If
		
		If lastPlanEntryDate <> "" _
		And gCategoryLastDateCompleted < lastPlanEntryDate _
		And status = 2 Then
			gCategoryLastDateCompleted = lastPlanEntryDate
		End If
		
		PushPlanEntryDates = ""
	End Function
	
	Function GetFirstEntryDateInCategory()
		GetFirstEntryDateInCategory = gCategoryFirstDate
	End Function
	
	Function GetLastEntryDateInCategory()
		GetLastEntryDateInCategory = gCategoryLastDate
	End Function
	
	Function GetLastEntryDateCompletedInCategory()
		GetLastEntryDateCompletedInCategory = gCategoryLastDateCompleted
	End Function
	
	Function CalculateEstTimeUsed(workingHours, estimation)
		CalculateEstTimeUsed = "Infinite"
		If estimation > 0 Then
			CalculateEstTimeUsed = "" & _
				Round(workingHours / estimation * 100)
		End If
	End Function
    ]]>
</ms:script>

</xsl:stylesheet>
  